package function.builtin;

import function.*;
import sexpression.*;

public class ATOM extends LispFunction {

    private static final int NUMBER_OF_ARGUMENTS = 1;
    private ArgumentValidator argumentValidator;

    public ATOM() {
        this.argumentValidator = new ArgumentValidator("ATOM");
        this.argumentValidator.setExactNumberOfArguments(NUMBER_OF_ARGUMENTS);
    }

    public SExpression call(Cons argumentList) {
        argumentValidator.validate(argumentList);
        SExpression argument = argumentList.getCar();

        return argument.atomp() ? Symbol.T : Nil.getUniqueInstance();
    }

}
